/*****************************************************************************
** PB.CH
**
** ProVision:Backup
** CA-Clipper 5.0 surface header file
**
** Copyright 1993 SofDesign International, Inc.
** All rights reserved
**
** tab spacing = 3
**
*****************************************************************************/


/*****************************************************************************
** #defines
*****************************************************************************/

#define PB_ERROR					-1			// general error flag

// 0000 - no error
#define ERROR_NONE				0			// no error

// 01xx - user errors
#define ERROR_INIT				100		// _pbInit() not called
#define ERROR_DOSVERSION		101		// PVB requires DOS 3.0 or above
#define ERROR_PASSWORD			102		// password does not match current disk

// 02xx - possibly recoverable file and disk errors
#define ERROR_DRIVETYPE			200		// drive type is not known or is invalid
#define ERROR_NODRIVE			201		// drive does not exist
#define ERROR_FILENOTFOUND		202		// file not found
#define ERROR_FILEOPEN			203		// unable to open file
#define ERROR_READ				204		// error on disk read
#define ERROR_DOSERROR			205		// a DOS error occurred
#define ERROR_BIOSERROR			206		// a BIOS error occurred
#define ERROR_CRC					207		// a restored file's CRC does not match the stored CRC

// 03xx - recoverable errors requiring disk insert
#define ERROR_DRIVENOTREADY	300		// drive is not ready
#define ERROR_WRITE				301		// error on disk write
#define ERROR_SAMESET			302		// a disk from the same backup set was inserted as a new disk
#define ERROR_WRITEPROTECT		303		// disk is write-protected
#define ERROR_MEDIATYPE			304		// a formatted disk of the wrong media type was inserted
#define ERROR_SYSTEMAREA		305		// error formatting or writing system area
#define ERROR_CONTAINSDATA		306		// disk contains data, according to overwrite option
#define ERROR_TIMEOUT			307		// timed out waiting for user response
#define ERROR_NONPVB				308		// disk is not a PVB disk
#define ERROR_SEQUENCE			309		// disk inserted out of sequence

// 18xx - fatal disk errors
#define ERROR_DISKBASE			1800		// error setting Disk Base Table
#define ERROR_BADFDC				1801		// Floppy Disk Controller (FDC) is probably bad
#define ERROR_SAVESTATE			1802		// unable to state to temp file
#define ERROR_RESTSTATE			1803		// unable to restore state from temp file

// 19xx - fatal memory errors
#define ERROR_VMALLOC			1900		// unable to alloc VM
#define ERROR_VMLOCK				1901		// unable to lock VM


#define BOP_ERROR					PB_ERROR	// an error occured
#define BOP_CANCEL				0			// backup cancelled
#define BOP_BEGIN					1			// backup step begun
#define BOP_END					2			// backup step ended
#define BOP_COMPLETE				3			// backup is complete
#define BOP_FILEBEGIN			4			// new file
#define BOP_FILEEND				5			// file is complete
#define BOP_NEXTVOL				6			// need next disk
#define BOP_TRACKWRITTEN		7			// track was written
#define BOP_TRACKREAD			7			// track was read
#define BOP_TRACKFORMATTED		8			// track was formatted and written
#define BOP_RESETARCHIVE		9			// archive bits are being reset
#define BOP_FILEESTIMATE		10			// estimating file
#define BOP_FILEEXISTS			11			// file to be restored already exists

#define BACT_CANCEL				PB_ERROR	// cancel backup
#define BACT_OK					0			// continue with backup
#define BACT_REDO					1			// redo failed operation
#define BACT_SKIPFILE			1			// skip to next file after error
#define BACT_SKIPVOL				1			// "rewind" to start of disk after error
#define BACT_OVERWRITE			1			// overwrite data on current disk

#define DTYPE_360					0			// 360K  5
#define DTYPE_1_2					1			// 1.2M  5
#define DTYPE_720					2			// 720K  3
#define DTYPE_1_44				3			// 1.44M 3
#define DTYPE_2_88				4			// 2.88M 3
#define DTYPE_UNKNOWN			5			// unknown (could not detect)

#define CREQ_NONE					0			// no compression
#define CREQ_TIME					1			// save time (always use CTYPE_LZ)
#define CREQ_VOLS					2			// save disks (test for best ratio)

#define CTYPE_NONE				0			// no compression
#define CTYPE_LZ					1			// LZ-derivative
#define CTYPE_HUFFMAN			2			// dynamic adaptive Huffman
#define CTYPE_RL					3			// run-length encoding

#define ETYPE_NONE				0			// no encryption
#define ETYPE_ENCODE				1			// simple encoding from a password

#define WARN_NONE					0			// never warn before overwrite
#define WARN_NONPVB				1			// warn on non-PVB disks
#define WARN_ALL					2			// always warn before overwrite

#define EST_BYTES					0			// byte estimate
#define EST_VOLS					1			// disk estimate
#define EST_FILES					2			// file estimate
#define EST_TIME					3			// time estimate (in seconds)

